function _aws_cdk_aws_appconfig_alpha_EnvironmentAttributes(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.application))
            _aws_cdk_aws_appconfig_alpha_IApplication(p.application);
        if (p.monitors != null)
            for (const o of p.monitors)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Monitor(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_EnvironmentOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.monitors != null)
            for (const o of p.monitors)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Monitor(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_EnvironmentProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.application))
            _aws_cdk_aws_appconfig_alpha_IApplication(p.application);
        if (p.monitors != null)
            for (const o of p.monitors)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Monitor(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_Environment(p) {
}
function _aws_cdk_aws_appconfig_alpha_MonitorType(p) {
}
function _aws_cdk_aws_appconfig_alpha_Monitor(p) {
}
function _aws_cdk_aws_appconfig_alpha_IEnvironment(p) {
}
function _aws_cdk_aws_appconfig_alpha_DeploymentStrategyProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.rolloutStrategy))
            _aws_cdk_aws_appconfig_alpha_RolloutStrategy(p.rolloutStrategy);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_DeploymentStrategy(p) {
}
function _aws_cdk_aws_appconfig_alpha_GrowthType(p) {
}
function _aws_cdk_aws_appconfig_alpha_DeploymentStrategyId(p) {
}
function _aws_cdk_aws_appconfig_alpha_RolloutStrategyProps(p) {
}
function _aws_cdk_aws_appconfig_alpha_RolloutStrategy(p) {
}
function _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p) {
}
function _aws_cdk_aws_appconfig_alpha_ActionPoint(p) {
}
function _aws_cdk_aws_appconfig_alpha_SourceType(p) {
}
function _aws_cdk_aws_appconfig_alpha_IEventDestination(p) {
}
function _aws_cdk_aws_appconfig_alpha_LambdaDestination(p) {
}
function _aws_cdk_aws_appconfig_alpha_SqsDestination(p) {
}
function _aws_cdk_aws_appconfig_alpha_SnsDestination(p) {
}
function _aws_cdk_aws_appconfig_alpha_EventBridgeDestination(p) {
}
function _aws_cdk_aws_appconfig_alpha_ActionProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.actionPoints != null)
            for (const o of p.actionPoints)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_ActionPoint(o);
        if (!visitedObjects.has(p.eventDestination))
            _aws_cdk_aws_appconfig_alpha_IEventDestination(p.eventDestination);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_Action(p) {
}
function _aws_cdk_aws_appconfig_alpha_Parameter(p) {
}
function _aws_cdk_aws_appconfig_alpha_ExtensionAttributes(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.actions != null)
            for (const o of p.actions)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Action(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_ExtensionOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.parameters != null)
            for (const o of p.parameters)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Parameter(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_ExtensionProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (p.actions != null)
            for (const o of p.actions)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Action(o);
        if (p.parameters != null)
            for (const o of p.parameters)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_Parameter(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_Extension(p) {
}
function _aws_cdk_aws_appconfig_alpha_IExtension(p) {
}
function _aws_cdk_aws_appconfig_alpha_ExtensibleBase(p) {
}
function _aws_cdk_aws_appconfig_alpha_IExtensible(p) {
}
function _aws_cdk_aws_appconfig_alpha_Platform(p) {
}
function _aws_cdk_aws_appconfig_alpha_IApplication(p) {
}
function _aws_cdk_aws_appconfig_alpha_ApplicationProps(p) {
}
function _aws_cdk_aws_appconfig_alpha_Application(p) {
}
function _aws_cdk_aws_appconfig_alpha_ConfigurationOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.deploymentStrategy))
            _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p.deploymentStrategy);
        if (p.deployTo != null)
            for (const o of p.deployTo)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IEnvironment(o);
        if (!visitedObjects.has(p.type))
            _aws_cdk_aws_appconfig_alpha_ConfigurationType(p.type);
        if (p.validators != null)
            for (const o of p.validators)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IValidator(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_ConfigurationProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.application))
            _aws_cdk_aws_appconfig_alpha_IApplication(p.application);
        if (!visitedObjects.has(p.deploymentStrategy))
            _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p.deploymentStrategy);
        if (p.deployTo != null)
            for (const o of p.deployTo)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IEnvironment(o);
        if (!visitedObjects.has(p.type))
            _aws_cdk_aws_appconfig_alpha_ConfigurationType(p.type);
        if (p.validators != null)
            for (const o of p.validators)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IValidator(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_IConfiguration(p) {
}
function _aws_cdk_aws_appconfig_alpha_HostedConfigurationOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.content))
            _aws_cdk_aws_appconfig_alpha_ConfigurationContent(p.content);
        if (!visitedObjects.has(p.deploymentStrategy))
            _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p.deploymentStrategy);
        if (p.deployTo != null)
            for (const o of p.deployTo)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IEnvironment(o);
        if (!visitedObjects.has(p.type))
            _aws_cdk_aws_appconfig_alpha_ConfigurationType(p.type);
        if (p.validators != null)
            for (const o of p.validators)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IValidator(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_HostedConfigurationProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.content))
            _aws_cdk_aws_appconfig_alpha_ConfigurationContent(p.content);
        if (!visitedObjects.has(p.application))
            _aws_cdk_aws_appconfig_alpha_IApplication(p.application);
        if (!visitedObjects.has(p.deploymentStrategy))
            _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p.deploymentStrategy);
        if (p.deployTo != null)
            for (const o of p.deployTo)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IEnvironment(o);
        if (!visitedObjects.has(p.type))
            _aws_cdk_aws_appconfig_alpha_ConfigurationType(p.type);
        if (p.validators != null)
            for (const o of p.validators)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IValidator(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_HostedConfiguration(p) {
}
function _aws_cdk_aws_appconfig_alpha_SourcedConfigurationOptions(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.location))
            _aws_cdk_aws_appconfig_alpha_ConfigurationSource(p.location);
        if (!visitedObjects.has(p.deploymentStrategy))
            _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p.deploymentStrategy);
        if (p.deployTo != null)
            for (const o of p.deployTo)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IEnvironment(o);
        if (!visitedObjects.has(p.type))
            _aws_cdk_aws_appconfig_alpha_ConfigurationType(p.type);
        if (p.validators != null)
            for (const o of p.validators)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IValidator(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_SourcedConfigurationProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.location))
            _aws_cdk_aws_appconfig_alpha_ConfigurationSource(p.location);
        if (!visitedObjects.has(p.application))
            _aws_cdk_aws_appconfig_alpha_IApplication(p.application);
        if (!visitedObjects.has(p.deploymentStrategy))
            _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy(p.deploymentStrategy);
        if (p.deployTo != null)
            for (const o of p.deployTo)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IEnvironment(o);
        if (!visitedObjects.has(p.type))
            _aws_cdk_aws_appconfig_alpha_ConfigurationType(p.type);
        if (p.validators != null)
            for (const o of p.validators)
                if (!visitedObjects.has(o))
                    _aws_cdk_aws_appconfig_alpha_IValidator(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_appconfig_alpha_SourcedConfiguration(p) {
}
function _aws_cdk_aws_appconfig_alpha_ConfigurationType(p) {
}
function _aws_cdk_aws_appconfig_alpha_ValidatorType(p) {
}
function _aws_cdk_aws_appconfig_alpha_ConfigurationSourceType(p) {
}
function _aws_cdk_aws_appconfig_alpha_IValidator(p) {
}
function _aws_cdk_aws_appconfig_alpha_JsonSchemaValidator(p) {
}
function _aws_cdk_aws_appconfig_alpha_LambdaValidator(p) {
}
function _aws_cdk_aws_appconfig_alpha_ConfigurationContent(p) {
}
function _aws_cdk_aws_appconfig_alpha_ConfigurationSource(p) {
}
function print(name, deprecationMessage) {
    const deprecated = process.env.JSII_DEPRECATED;
    const deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn";
    const message = `${name} is deprecated.\n  ${deprecationMessage.trim()}\n  This API will be removed in the next major release.`;
    switch (deprecationMode) {
        case "fail":
            throw new DeprecationError(message);
        case "warn":
            console.warn("[WARNING]", message);
            break;
    }
}
function getPropertyDescriptor(obj, prop) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
    if (descriptor) {
        return descriptor;
    }
    const proto = Object.getPrototypeOf(obj);
    const prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
    if (prototypeDescriptor) {
        return prototypeDescriptor;
    }
    return {};
}
const visitedObjects = new Set();
class DeprecationError extends Error {
    constructor(...args) {
        super(...args);
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: true,
            value: "DeprecationError",
            writable: false,
        });
    }
}
module.exports = { print, getPropertyDescriptor, DeprecationError, _aws_cdk_aws_appconfig_alpha_EnvironmentAttributes, _aws_cdk_aws_appconfig_alpha_EnvironmentOptions, _aws_cdk_aws_appconfig_alpha_EnvironmentProps, _aws_cdk_aws_appconfig_alpha_Environment, _aws_cdk_aws_appconfig_alpha_MonitorType, _aws_cdk_aws_appconfig_alpha_Monitor, _aws_cdk_aws_appconfig_alpha_IEnvironment, _aws_cdk_aws_appconfig_alpha_DeploymentStrategyProps, _aws_cdk_aws_appconfig_alpha_DeploymentStrategy, _aws_cdk_aws_appconfig_alpha_GrowthType, _aws_cdk_aws_appconfig_alpha_DeploymentStrategyId, _aws_cdk_aws_appconfig_alpha_RolloutStrategyProps, _aws_cdk_aws_appconfig_alpha_RolloutStrategy, _aws_cdk_aws_appconfig_alpha_IDeploymentStrategy, _aws_cdk_aws_appconfig_alpha_ActionPoint, _aws_cdk_aws_appconfig_alpha_SourceType, _aws_cdk_aws_appconfig_alpha_IEventDestination, _aws_cdk_aws_appconfig_alpha_LambdaDestination, _aws_cdk_aws_appconfig_alpha_SqsDestination, _aws_cdk_aws_appconfig_alpha_SnsDestination, _aws_cdk_aws_appconfig_alpha_EventBridgeDestination, _aws_cdk_aws_appconfig_alpha_ActionProps, _aws_cdk_aws_appconfig_alpha_Action, _aws_cdk_aws_appconfig_alpha_Parameter, _aws_cdk_aws_appconfig_alpha_ExtensionAttributes, _aws_cdk_aws_appconfig_alpha_ExtensionOptions, _aws_cdk_aws_appconfig_alpha_ExtensionProps, _aws_cdk_aws_appconfig_alpha_Extension, _aws_cdk_aws_appconfig_alpha_IExtension, _aws_cdk_aws_appconfig_alpha_ExtensibleBase, _aws_cdk_aws_appconfig_alpha_IExtensible, _aws_cdk_aws_appconfig_alpha_Platform, _aws_cdk_aws_appconfig_alpha_IApplication, _aws_cdk_aws_appconfig_alpha_ApplicationProps, _aws_cdk_aws_appconfig_alpha_Application, _aws_cdk_aws_appconfig_alpha_ConfigurationOptions, _aws_cdk_aws_appconfig_alpha_ConfigurationProps, _aws_cdk_aws_appconfig_alpha_IConfiguration, _aws_cdk_aws_appconfig_alpha_HostedConfigurationOptions, _aws_cdk_aws_appconfig_alpha_HostedConfigurationProps, _aws_cdk_aws_appconfig_alpha_HostedConfiguration, _aws_cdk_aws_appconfig_alpha_SourcedConfigurationOptions, _aws_cdk_aws_appconfig_alpha_SourcedConfigurationProps, _aws_cdk_aws_appconfig_alpha_SourcedConfiguration, _aws_cdk_aws_appconfig_alpha_ConfigurationType, _aws_cdk_aws_appconfig_alpha_ValidatorType, _aws_cdk_aws_appconfig_alpha_ConfigurationSourceType, _aws_cdk_aws_appconfig_alpha_IValidator, _aws_cdk_aws_appconfig_alpha_JsonSchemaValidator, _aws_cdk_aws_appconfig_alpha_LambdaValidator, _aws_cdk_aws_appconfig_alpha_ConfigurationContent, _aws_cdk_aws_appconfig_alpha_ConfigurationSource };
